const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const vehicle_compliance = sequelize.define(
    'vehicle_compliance',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

registration_expiry: {
        type: DataTypes.DATE,
      
      

      },

fitness_expiry: {
        type: DataTypes.DATE,
      
      

      },

insurance_expiry: {
        type: DataTypes.DATE,
      
      

      },

insurance_policy_no: {
        type: DataTypes.TEXT,
      
      

      },

certificate_no: {
        type: DataTypes.TEXT,
      
      

      },

mileage: {
        type: DataTypes.INTEGER,
      
      

      },

registration_status: {
        type: DataTypes.ENUM,
      
      

        values: [

"valid",


"expiring",


"expired",


"unknown"

        ],

      },

insurance_status: {
        type: DataTypes.ENUM,
      
      

        values: [

"valid",


"expiring",


"expired",


"unknown"

        ],

      },

fitness_status: {
        type: DataTypes.ENUM,
      
      

        values: [

"valid",


"expiring",


"expired",


"unknown"

        ],

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  vehicle_compliance.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity



























//end loop



    db.vehicle_compliance.belongsTo(db.companies, {
      as: 'company',
      foreignKey: {
        name: 'companyId',
      },
      constraints: false,
    });

    db.vehicle_compliance.belongsTo(db.vehicles, {
      as: 'vehicle',
      foreignKey: {
        name: 'vehicleId',
      },
      constraints: false,
    });




    db.vehicle_compliance.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.vehicle_compliance.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return vehicle_compliance;
};


